package com.example.administrator.wingcool_gt9_apk;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.graphics.drawable.ColorDrawable;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.support.v7.app.AppCompatActivity;
import android.util.DisplayMetrics;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import static android.os.Build.VERSION_CODES.M;

//===============================================================//
//=================================================================//

public class GT9MainActivity extends AppCompatActivity
        implements OpenDevicesReceiver.OpenDevicesListener, View.OnClickListener {

    private static final int CONNECTED_SUCCESS = 0;
    private static final int RECEIVER_MESSAGE_SUCCESS = 1;
    private static final int SEND_MESSAGE_SUCCESS = 2;
    private static final int CONNECTED_FAILED = 3;
    private static final String USB_ACTION = "com.host2device";
    private static final String ACTION_USB_PERMISSION = "com.host2device.USB_PERMISSION";
    private ExecutorService mThreadPool;
    private UsbManager mUsbManager;
    private OpenDevicesReceiver mOpenDevicesReceiver;
    private UsbDeviceConnection mUsbDeviceConnection;
    private UsbEndpoint mUsbEndpointOut;
    private UsbEndpoint mUsbEndpointIn;
    private boolean mToggle = true;
    private boolean isDetached = false;
    private byte[] mBytes = new byte[64];
    private boolean isReceiverMessage = true;
    private boolean isNeedFindDevice  = true;

    public boolean isS818Device  = false;

    private UsbInterface mUsbInterface;
    private TextView mShow;
    private TextView tvIPAddress;
    private Context mShowID;
    private Button btnExit;

    private Button btnDataAnalysis;
    private Context mDataAnalysisContext;

    public static List<Activity> activityList = new LinkedList();

    Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case CONNECTED_SUCCESS://??????????????????
                    //mError.setText("");
                    //mSendMessage.setEnabled(true);
                    //String avalue = "S818 is connected";

                    mShow.setText(R.string.connected);//????????
                    break;
                case CONNECTED_FAILED://??????????????????
                    //String bvalue = "S818 is disconnected";
                    //mError.setText("");
                    //mSendMessage.setEnabled(true);

                    mShow.setText(R.string.disconnected);//????????
                    break;

                case RECEIVER_MESSAGE_SUCCESS://??????????????

                    break;

                case SEND_MESSAGE_SUCCESS://????????????
                    //mMessage.setText("");
                    break;
            }
        }
    };

    //==========================================================================================//

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_gt9_main);
        ConstantsActivity.activityList.add(this);

        RadioGroup radio = (RadioGroup) findViewById(R.id.radio);
        final RadioButton radioButtonen = (RadioButton) findViewById(R.id.radio_en);
        final RadioButton radioButtonzh = (RadioButton) findViewById(R.id.radio_zh);
        //Locale curLocale = getResources().getConfiguration().locale;
        //String language = locale.getLanguage();

        //通过Locale的equals方法，判断出当前语言环境
        //if (curLocale.equals(Locale.CHINESE)) {
        if (ConstantsActivity.bHaveChange == false) {
            if (isZh()) {
                ConstantsActivity.langae = "zh";
            } else {//if(curLocale.equals(Locale.ENGLISH)){
                ConstantsActivity.langae = "en";
            }
        }

        if (ConstantsActivity.langae.equals("zh")) {
            radioButtonzh.setChecked(true);
            radioButtonen.setChecked(false);
        } else {
            radioButtonen.setChecked(true);
            radioButtonzh.setChecked(false);
        }

        if (ConstantsActivity.bHaveChange == false) {
            switchLanguage(ConstantsActivity.langae);
        }

        radio.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (checkedId == R.id.radio_zh) {
                    ConstantsActivity.langae = "zh";
                    radioButtonen.setChecked(false);
                } else {
                    radioButtonzh.setChecked(false);
                    ConstantsActivity.langae = "en";
                }
                ConstantsActivity.bHaveChange = true;
                changelanguage();
            }
        });

        RadioGroup screenradio = (RadioGroup) findViewById(R.id.screenradio);
        final RadioButton radioButtonLandscape = (RadioButton) findViewById(R.id.radio_landscape);
        final RadioButton radioButtonPortrait = (RadioButton) findViewById(R.id.radio_portrait);

        if (ConstantsActivity.screenview.equals("landscape")) {
            radioButtonLandscape.setChecked(true);
            radioButtonPortrait.setChecked(false);
        } else {
            radioButtonPortrait.setChecked(true);
            radioButtonLandscape.setChecked(false);
        }

        if (ConstantsActivity.bScreenHaveChange == false) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
        }

        screenradio.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (checkedId == R.id.radio_landscape) {
                    setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
                    ConstantsActivity.screenview = "landscape";
                } else {
                    setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
                    ConstantsActivity.screenview = "portrait";
                }
                ConstantsActivity.bScreenHaveChange = true;
            }
        });

        init();//
    }

    private boolean isZh() {
        Locale locale = getResources().getConfiguration().locale;
        String language = locale.getLanguage();
        if (language.endsWith("zh"))
            return true;
        else
            return false;
    }

    private void changelanguage() {
        Locale locale = new Locale(ConstantsActivity.langae);
        Locale.setDefault(locale);
        Configuration config = new Configuration();
        config.locale = locale;
        Resources resources = getResources();
        resources.updateConfiguration(config, resources.getDisplayMetrics());

        //让之前打开的所有界面全部彻底关闭
        for (Activity activity : ConstantsActivity.activityList) {
            activity.finish();
        }
        //回到应用的首页
        startActivity(new Intent(this, GT9MainActivity.class));
    }
    //核心设置的代码
    protected void switchLanguage(String language) {
        Resources resources = getResources();
        Configuration config = resources.getConfiguration();
        DisplayMetrics dm = resources.getDisplayMetrics();
        switch (language) {
            case "zh":
                config.locale = Locale.CHINESE;
                resources.updateConfiguration(config, dm);
                break;
            case "en":
                config.locale = Locale.ENGLISH;
                resources.updateConfiguration(config, dm);
                break;
            default:
                config.locale = Locale.US;
                resources.updateConfiguration(config, dm);
                break;
        }
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
    }

    /** Called when the user taps the Config Setting button */
    public void ConfigSetting(View view) {
        Intent intent = new Intent(this, Config.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    /** Called when the user taps the Firmware Update button */
    public void FirmwareUpdate(View view) {
        Intent intent = new Intent(this, FirmwareUpdate.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    /** Called when the user taps the Data Analysis button */
    public void DataAnalysis(View view) {
        Intent intent = new Intent(this, DataAnalysis.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    /** Called when the user taps the Noise Analysis button */
    public void NoiseAnalysis(View view) {
        Intent intent = new Intent(this, NoiseAnalysis.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    /** Called when the user taps the Demo Tools button */
    public void DemoTools(View view) {
        Intent intent = new Intent(this, DemoTools.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    /** Called when the user taps the IIC Operation button */
    public void IICOperation(View view) {
        Intent intent = new Intent(this, IICOperation.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    /** Called when the user taps the Test Operation button */
    public void TestOperation(View view) {
        Intent intent = new Intent(this, TestOperation.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    /** Called when the user taps the Contact Us button */
    public void ContactUs(View view) {
        Intent intent = new Intent(this, ContactUs.class);
        //EditText editText = (EditText) findViewById(R.id.editText);
        //String message = editText.getText().toString();
        //intent.putExtra(EXTRA_MESSAGE, message);
        startActivity(intent);
    }

    //===============================================================//
    private void init() {
        initView();
        initData();
        openDevices();
        //GetIPAddress();
    }

    private void initView() {
        mShow = (TextView) findViewById(R.id.show);
        tvIPAddress = (TextView) findViewById(R.id.ipaddressshow);

        tvIPAddress.setText("IP Address : " + GetIPAddress());
    }

    private void initData() {
        mShowID = getApplicationContext();

        mThreadPool = Executors.newFixedThreadPool(5);

        mUsbManager = (UsbManager) getSystemService(Context.USB_SERVICE);

        btnExit = (Button) findViewById(R.id.Exit);
        btnExit.setOnClickListener(this);

        mDataAnalysisContext = GT9MainActivity.this;
        btnDataAnalysis = (Button) findViewById(R.id.DataAnalysis);
    }

    @Override
    public void onClick(final View v) {
        switch (v.getId()) {
            case R.id.Exit:   //Exit
                exit();
                break;
        }
    }

    /**
     * ???? , ??????????
     */
    private void openDevices() {
        //????(??)
        mOpenDevicesReceiver = new OpenDevicesReceiver(this);
        mThreadPool.execute(new Runnable() {
            @Override
            public void run() {
                SystemClock.sleep(1000);
                PendingIntent pendingIntent = PendingIntent.getBroadcast(mShowID, 0, new Intent(ACTION_USB_PERMISSION), 0);
                IntentFilter intentFilter = new IntentFilter(USB_ACTION);

                registerReceiver(mOpenDevicesReceiver, intentFilter);

                while(true)
                {
                    isNeedFindDevice = true;

                    while (isNeedFindDevice) {
                        SystemClock.sleep(100);
                        isS818Device = false;
                        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
                        if (deviceList != null) {

                            for (UsbDevice usbDevice : deviceList.values()) {
                                int productId = usbDevice.getProductId();
                                int vendorId = usbDevice.getVendorId();
                                if ((productId == 0x0818 && vendorId == 0x27C0)
                                        ||(productId == 0x0001 && vendorId == 0x222A))   //奕力的PID和VID
                                {
                                    isS818Device = true;
                                    if (mUsbManager.hasPermission(usbDevice)) {
                                        initDevice();
                                    }
                                    else {
                                        // mUsbManager.requestPermission(usbDevice, PendingIntent.getBroadcast(mContext, 0, new Intent(""), 0));//pendingIntent
                                        mUsbManager.requestPermission(usbDevice,pendingIntent);

                                        SystemClock.sleep(1500);
                                        break;
                                    }//if (mUsbManager.hasPermission(usbDevice))

                                    break;

                                }  // if (productId == 0x0818 && vendorId == 0x27C0)
                                else{

                                }
                            }  // for (UsbDevice usbDevice : deviceList.values())

                            if(isS818Device==false){
                                mUsbEndpointOut = null;

                                mUsbEndpointIn = null;

                                mHandler.sendEmptyMessage(CONNECTED_FAILED);
                            }
                            //break;
                        } //if (deviceList != null)
                        else {
                            // mError.setText("请连接USB");
                        }
                        // }
                    }  //while (isNeedFindDevice)
                }  //while(1)

            }   //ThreadPool
        });   //ThreadPool
    }

    /**
     * ??????????(????) , ??????????Accessory?????? , ??????PID??????Google??????2?????????????????? ,
     */
    private void initDevice() {
        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
        Collection<UsbDevice> values = deviceList.values();
        if (!values.isEmpty()) {
            for (UsbDevice usbDevice : values) {
                int productId = usbDevice.getProductId();
                if (productId == 0x0818 || productId == 0x0001 ) {  //0x0001是奕力的PID

                    if (mUsbManager.hasPermission(usbDevice)) {

                        mUsbDeviceConnection = mUsbManager.openDevice(usbDevice);
                        if (mUsbDeviceConnection != null) {

                            {

                                UsbInterface usbInterface = usbDevice.getInterface(1);

                                if(UsbConstants.USB_CLASS_HID != usbInterface.getInterfaceClass())
                                {
                                    // continue;
                                }

                                for (int i = 0; i < usbInterface.getEndpointCount(); i++) {
                                    UsbEndpoint ep = usbInterface.getEndpoint(i);
                                    if (ep.getType() == UsbConstants.USB_ENDPOINT_XFER_BULK) {
                                        if (ep.getDirection() == UsbConstants.USB_DIR_OUT) {
                                            //mUsbEndpointIn = ep;
                                            mUsbEndpointOut = ep;
                                        } else {
                                            //mUsbEndpointOut = ep;
                                            mUsbEndpointIn = ep;
                                        }
                                    }
                                    else{
                                        // mHandler.sendEmptyMessage(CONNECTED_SUCCESS);
                                    }
                                }
                                if ((null == mUsbEndpointIn) || (null == mUsbEndpointOut)) {

                                    int i = mUsbDeviceConnection.controlTransfer(0x00, 0x09,
                                            0x002, 0, null, 0, 100);
                                    SystemClock.sleep(1000);
                                    if(i>=0){
                                        //mHandler.sendEmptyMessage(DEBUG_MESSAGE_SUCCESS);
                                    }
                                    else{
                                        //mHandler.sendEmptyMessage(DEBUG_MESSAGE_ERROR);
                                    }
                                } else {
                                    //if(0x80 == mUsbEndpointIn)
                                    //mlog1.setEnabled(true);
                                    mToggle = false;
                                    isDetached = true;
                                    isNeedFindDevice = false;
                                    // mSendMessage.setEnabled(true);

                                    mUsbInterface = usbInterface;
                                    mUsbDeviceConnection = mUsbManager.openDevice(usbDevice);
                                    if(null != mUsbEndpointIn){
                                        mHandler.sendEmptyMessage(CONNECTED_SUCCESS);
                                    }

                                }
                            }
                        }
                    } else {
                        mUsbManager.requestPermission(usbDevice, PendingIntent.getBroadcast(mShowID, 0, new Intent(""), 0));
                    }
                }
            }
        } else {
            // finish();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

        if (mUsbDeviceConnection != null) {
            mUsbDeviceConnection.releaseInterface(mUsbInterface);
            mUsbDeviceConnection.close();
            mUsbDeviceConnection = null;
        }
        mUsbEndpointIn = null;
        mUsbEndpointOut = null;
        mToggle = false;
        isReceiverMessage = false;
        isNeedFindDevice = false;
        mThreadPool.shutdownNow();
        unregisterReceiver(mOpenDevicesReceiver);
    }

    public void exit()
    {
        for(Activity act:activityList)
        {
            act.finish();
        }

        System.exit(0);
    }

    public static String GetIPAddress()
    {
       try {

            for (Enumeration<NetworkInterface> enNetI = NetworkInterface.getNetworkInterfaces(); enNetI.hasMoreElements(); ) {

                NetworkInterface netI = enNetI.nextElement();

                for (Enumeration<InetAddress> enumIpAddr = netI.getInetAddresses(); enumIpAddr.hasMoreElements(); ) {

                    InetAddress inetAddress = enumIpAddr.nextElement();

                    if (inetAddress instanceof Inet4Address && !inetAddress.isLoopbackAddress()) {

                        return inetAddress.getHostAddress();

                    }

                }

            }

        } catch (SocketException e) {

            e.printStackTrace();

        }

        return "0.0.0.0";
    }
}

class OpenDevicesReceiver extends BroadcastReceiver {

    private OpenDevicesListener mOpenDevicesListener;

    public OpenDevicesReceiver(OpenDevicesListener openDevicesListener) {
        mOpenDevicesListener = openDevicesListener;
    }

    @Override
    public void onReceive(Context context, Intent intent) {
        UsbDevice usbDevice = intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
        if (intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false)) {
            if (usbDevice != null) {
                // mOpenDevicesListener.openAccessoryModel(usbDevice);
            } else {
                //mOpenDevicesListener.openDevicesError();
            }
        } else {
            //mOpenDevicesListener.openDevicesError();
        }
    }

    public interface OpenDevicesListener {

        /**
         * 打开设备(手机)失败
         */
        //void openDevicesError();
    }

}